<?php

$host = "127.0.0.1";
$user = "testuser";
$pw = "123alexcherukara456";
$db = "personsdb";

$json = file_get_contents( "php://input" );
$jsall = array();
$jsone = array();
$jsall = json_decode( $json, true );
$jsone = $jsall[0];
	
$action = $jsone["Action"];

if( !($con = mysqli_connect( $host, $user, $pw ))){
  print json_encode( "Error: Cannot connect to database" );
  die( mysqli_error() );
}
mysqli_select_db( $con, $db ) or die( mysqli_error() );
mysqli_query( $con, "SET CHARACTER SET utf8" );
mysqli_query( $con, "SET NAMES 'utf8'" );
	
switch( $action ){

  Case "InsertPerson":
    $pname = stripslashes( mysqli_real_escape_string( $con, $jsone["name"] ));
    $pbirthdate = stripslashes( mysqli_real_escape_string( $con, $jsone["birthdate"] ));
    $pinfo = stripslashes( mysqli_real_escape_string( $con, $jsone["info"] ));
    echo "<html><body>Name=$pname,Birthdate=$pbirthdate</body></html>";		
    $stmt = $con->prepare( "INSERT INTO persons (pname, pbirthdate, pinfo) VALUES (?, ?, ?)" );
    $rc = $stmt->bind_param( "sss", $pname, $pbirthdate, $pinfo );
    $rc = $stmt->execute();
    $iid = $stmt->insert_id;
    if( $iid == 0 ){
      exit( json_encode( array( array( 'InsertPerson' => 'failed' ))));
    }else{
      exit( json_encode( array( array( 'InsertPerson' => 'ok', 'pid' =>  $iid ))));
    }		
    break;

  Case "UpdatePerson":
    $pid = stripslashes( mysqli_real_escape_string( $con, $jsone["pid"] ));
    $pname = stripslashes( mysqli_real_escape_string( $con, $jsone["name"] ));
    $pbirthdate = stripslashes( mysqli_real_escape_string( $con, $jsone["birthdate"] ));
    $pinfo = stripslashes( mysqli_real_escape_string( $con, $jsone["info"] ));
		
    $stmt = $con->prepare( "UPDATE persons SET pname = ?, pbirthdate = ?, pinfo = ? WHERE pid = ?" );
    $rc = $stmt->bind_param( "sssi", $pname, $pbirthdate, $pinfo, $pid );
    $rc = $stmt->execute();
    $ar = $stmt->affected_rows;
    if( $ar < 1 ){
      exit( json_encode( array( array( 'UpdatePerson' => 'updatenorow' ))));
    }else{
      exit( json_encode( array( array( 'UpdatePerson' => 'updateok' ))));	
    }		
    break;

  Case "DeletePerson":
    $pid=stripslashes( mysqli_real_escape_string( $con, $jsone["pid"] ));
		
    $stmt = $con->prepare( "DELETE FROM persons WHERE pid = ?" );
    $rc = $stmt->bind_param( "i", $pid );
    $rc = $stmt->execute();
    $ar = $stmt->affected_rows;
    if( $ar < 1 ){
      exit( json_encode( array( array( 'DeletePerson' => 'deletenorow' ))));
    }else{
      exit( json_encode( array( array( 'DeletePerson' => 'deleteok' ))));	
    }
    break;

  Case "GetAllPersons":
    $stmt = $con->prepare( "SELECT * from persons ORDER BY pid ASC" );
    $rc = $stmt->execute();
    $q = $stmt->get_result();
    $count = mysqli_num_rows( $q );
    $stmt->close();
    $rows = array();
    while( $r = mysqli_fetch_assoc( $q )){
      $rows[] = $r;
    }
    exit( json_encode( $rows ));
    break;

  Case "Search":
    $parms = "";
    $like = FALSE;
    DoParms( $con, $jsone, $parms, $like );
    $q = $con->query( "SELECT * FROM persons WHERE $parms" );
    $count = mysqli_num_rows( $q );
    // did we find any exact match?
    if( $count == 0 ){
      // no, look for "like" match
      $like = TRUE;
      DoParms( $con, $jsone, $parms, $like );
      $q = $con->query( "SELECT * FROM persons WHERE $parms" );
      $count = mysqli_num_rows( $q );
    }
    $rows = array();
    while( $r = mysqli_fetch_assoc( $q )){
      $rows[] = $r;
    }
    exit( json_encode( $rows ));
  break;

  default:
    print json_encode( "Error: Action not defined (" . $action . ")" );
}	 

function DoParms( $con, $jsone, &$parms, $like ){
    $pname = stripslashes( mysqli_real_escape_string( $con, $jsone["name"] ));
    if( $pname !== '' ){
      if( $like )
        $parms = "pname LIKE '%$pname%'";
      else
        $parms = "pname = '$pname'";
    }

    $pbirthdate = stripslashes( mysqli_real_escape_string( $con, $jsone["birthdate"] ));
    if( $pbirthdate !== '' ){
      if( $parms !== '' ) $parms .= ", ";
      if( $like )
        $parms .= "pbirthdate LIKE '%$pbirthdate%'";
      else
        $parms .= "pbirthdate = '$pbirthdate'";
    }
    $pinfo = trim( stripslashes( mysqli_real_escape_string( $con, $jsone["info"] )));
    if( $pinfo !== '' ){
       if( $parms !== '' ) $parms .= ", ";
       if( $like )
         $parms .= "pinfo LIKE '%$pinfo%'";
       else
         $parms .= "pinfo = '$pinfo'";
    }
}
?>